#include <stdio.h>
#include <stdlib.h>
#include <assert.h>
#include "pqueue.h"

void pqueue_print(FILE* f, pqueue_t* pq) {
  fprintf(f, "[");
  {int i; for(i = 0; i < pq->num; i++) {
    fprintf(f, "%d%s",
            pq->data[i],
            (i == (pq->num - 1)) ? "" : ", ");
  }}
  fprintf(f, "]");          
}

enum {
  PRINT_QUEUE = 0
} flags;

int pqueue_test(int argc, char** prgctx) {
  const int SIZE = 20;
  pqueue_t pq;
  FILE* f = stdout;

  srand(time(0));
  
  flags = PRINT_QUEUE;
  
  pqueue_init(&pq);
  
  {int i; for(i = 0; i < SIZE; i++) {
    void* x = (void*) (rand() % (SIZE * 2));
    if(flags & PRINT_QUEUE) {
      pqueue_print(f, &pq);
      fprintf(f, "\n");
    }
    pqueue_push(&pq, x);
    if(flags & PRINT_QUEUE) {
      pqueue_print(f, &pq);
      fprintf(f, "\n");
    }}
  }

  int last = -1;  
  {int i; for(i = 0; i < SIZE; i++) {
    int elt = (int) pqueue_pop(&pq);
    fprintf(f, "%d\n", elt);
    assert(elt >= last);
    if(flags & PRINT_QUEUE) {
      pqueue_print(f, &pq);
      fprintf(f, "\n");
    }
    last = elt;
  }}
  return 0;
}

int main(int argc, char** prgctx) {
  pqueue_test(argc, prgctx);
  return 0;
}
