
#ifndef __VECTOR_H__
#define __VECTOR_C__
#include "vector.h"
#undef __VECTOR_C__
#endif

#include <assert.h>
#include <string.h>

VECTOR_FUN
VECTOR(_t)* VECTOR(_init)(VECTOR(_t)* v, VECTOR(_num_t) size) {
  if(size)
    v->data = VECTOR_MALLOC(sizeof(VECTOR(_val_t)) * size);
  else
    v->data = NULL;
  v->size = size;
  v->num = 0;
  return v;
}

VECTOR_FUN
VECTOR(_t)* VECTOR(_from_array)(VECTOR(_t)* v, int valc, VECTOR(_val_t)* vals) {
  v->data = vals;
  v->size = valc;
  v->num = valc;
  return v;
}


VECTOR_FUN
void VECTOR(_push)(VECTOR(_t)* v, VECTOR(_val_t) val) {
  if(v->num == v->size) {
    VECTOR(_t) vv;
    VECTOR(_num_t) i;
    
    VECTOR(_init)(&vv, v->size * 2 + 1);
    for(i = 0; i < v->num; i++)
      vv.data[i] = v->data[i];
    vv.num = v->num;
    VECTOR_FREE(v->data);
    *v = vv;
  }
  v->data[v->num ++] = val;
}

VECTOR_FUN
int VECTOR(_isempty)(VECTOR(_t)* v) {
  return !v->num;
}

VECTOR_FUN
hash_val_t VECTOR(_hash)(VECTOR(_t)* v) {
  VECTOR(_num_t) i;
  hash_val_t hash = 0;
  for(i = 0; i < v->num; i++) {
    hash = hash_char_joaat(hash,
                           (unsigned char*) &(v->data[i]),
                           sizeof(VECTOR(_val_t)));
  }
  return hash;
}


VECTOR_FUN
int VECTOR(_equals)(VECTOR(_t)* v, VECTOR(_t)* u) {
  if(v->num != u->num)
    return 0;
  else {
    int i;
    for(i = 0; i < v->num; i++) {
      int j;
      int nwords = sizeof(VECTOR(_val_t)) / sizeof(void*);
      void** vv = (void**) &(v->data[i]);
      void** uu = (void**) &(u->data[i]);
      /* TODO -- make this better than physical word-by-word
         comparison -- perhaps a vector-functor argument. */
      for(j = 0; j < nwords; j+= sizeof(void*)) {
        if(vv[j] != uu[j])
          return 0;
      }
    }                          
    return 1;
  }
}


VECTOR_FUN
VECTOR(_val_t) VECTOR(_pop)(VECTOR(_t)* v) {
  assert(v->num);
  return v->data[-- v->num];
}

VECTOR_FUN
VECTOR(_val_t)* VECTOR(_begin)(VECTOR(_t)* v) {
  return &v->data[0];  
}

VECTOR_FUN
VECTOR(_val_t)* VECTOR(_end)(VECTOR(_t)* v) {
  return &v->data[v->num];
}

VECTOR_FUN
VECTOR(_t)* VECTOR(_copy)(VECTOR(_t)* srcv, VECTOR(_t)* dstv) {
  int i;
  VECTOR(_init)(dstv, srcv->size);
  for(i = 0; i < srcv->num; i++) dstv->data[i] = srcv->data[i];
  dstv->num = srcv->num;
  return dstv;
}

VECTOR_FUN
VECTOR(_t)* VECTOR(_copy_shallow)(VECTOR(_t)* srcv, VECTOR(_t)* dstv) {
  if(srcv) {
    *dstv = *srcv;
  }
  else {
    VECTOR(_init)(dstv, 0);
  }
  return dstv;
}

VECTOR_FUN
VECTOR(_t)* VECTOR(_copy_deep)(VECTOR(_t)* srcv, VECTOR(_t)* dstv) {
  *dstv = *srcv;
  dstv->data = VECTOR_MALLOC(srcv->size * sizeof(VECTOR(_val_t)));
  memcpy(dstv->data, srcv->data, srcv->num * sizeof(VECTOR(_val_t)));
  return dstv;
}


VECTOR_FUN
void VECTOR(_cleanup)(VECTOR(_t)* v) {
  VECTOR_FREE(v->data);
  v->data = NULL;
  v->num = 0;
  v->size = 0;
}
