/* BEGIN -- debugging macros:

   DBSTR_CLOSURE, DBVAS_PRGCX -- for making consistant identification
   strings in logging output.
*/

void actk__remove_interval_files(actk_state_t* st);
void actk__print_interval(actk_state_t* st, actk_interval_t interval, const char* fmt, ...);
void actk__verify_interval_closures(actk_state_t* st, actk_interval_t interval);


#define DBSTR_STATE "<state @%p [%p, %p)>"
#define DBVAS_STATE(st) \
   (st), (st)->now, \
   (st)->chpctx ? (st)->chpctx->end : NULL

#define DBSTR_HEADER ".,-~^`'-,.,-~^`'-"

#ifdef ACTK_DB

#define DBSTR_CLOSURE "<closure %s %d @%p>"
#define DBVAS_CLOSURE(closure) \
   (closure) ? (closure)->recctx->fun->sig->name : "null", \
   (closure) ? (closure)->num : 0, \
   (closure)

#define DBSTR_ALLOC "<alloc @%p>"
#define DBVAS_ALLOC(alloc) (alloc)

#define DBSTR_INTERVAL "<interval %p %p>"
#define DBVAS_INTERVAL(interval) \
   (interval).start, (interval).end

#define DBSTR_MODREF "<modref @%p>"
#define DBVAS_MODREF(modref) (modref)

#define actk_print_interval(st, interval, fmt, ...)                   \
  ((st->flags & ACTK_LOG_INTERVALS)                                   \
  ? actk__print_interval(st, (interval), (fmt) ,##__VA_ARGS__ ) : 0)

#define actk_assert_current_interval actk__assert_current_interval
#define actk_verify_interval_closures actk__verify_interval_closures

#else

#define DBSTR_CLOSURE "<closure %s @%p>"
#define DBVAS_CLOSURE(closure) \
   (closure) ? (closure)->recctx->fun->sig->name : "NULL", \
   (closure)

#define DBSTR_ALLOC "<alloc @%p>"
#define DBVAS_ALLOC(alloc_hdr) \
   ((alloc_hdr) + 1)

#define actk_print_interval(...) ;
#define actk_assert_current_interval(...) ;
#define actk_verify_interval_closures(...) ;
#endif

/* END -- debugging macros */
