#ifndef __HEAP_H__
#define __HEAP_H__

#include "stats.h"

/* Wrappers for Libc's malloc and free (see malloc(3) and free(3)) */
/* These just do some extra stuff for statistics purposes. */
void* actk_libc_malloc(int size);
int   actk_libc_sizeof(void* ptr);
void  actk_libc_free(void* ptr);

/* Wrappers for the freeset, which should be faster and a bit more
   space-efficient than malloc/free for commonly-used sizes.  Should
   be used everywhere where the freer knows the size and this size is
   sufficiently small. */
void  actk_freeset_init();
void* actk_freeset_malloc(int size);
void  actk_freeset_free(int size, void* ptr);

/* optional: to record heap-bytes malloc'd and free'd */
void  actk_heap_set_stats(actk_stats_t* stats);

#endif
