/* Matthew Hammer <hammer@tti-c.org> */
/* Sat Oct 14 13:13:14 CDT 2006 */

#ifndef __LOGGING_H__
#define __LOGGING_H__

#include "actk_types.h"

extern int actk__log_major_num;
extern int actk__log_minor_num;

#define logcolor_hi "\x1b[7m"
#define logcolor_norm "\x1b[0m"

int logcatf_full(actk_state_t* st,
                 const char* file,
                 const char* fun,
                 int line,
                 const char* fmt, ...);

#ifdef ACTK_DB
#define logcatf(st, fmt, ...) \
        logcatf_full(st, __FILE__, __func__, __LINE__, fmt "\n",##__VA_ARGS__)

#define log_inc_major_num(...) \
        actk__log_major_num++; \
        actk__log_minor_num=0; \
        logcatf(st, "%d --> %d --------------------------------------------------------",\
                actk__log_major_num - 1, actk__log_major_num);

#define log_inc_minor_num(...) \
        actk__log_minor_num++;

#else
#define logcatf(st, fmt, ...)
#define log_inc_major_num(...) 
#define log_inc_minor_num(...)
#endif


#endif
