#ifndef __MEMOTBL_H__
#define __MEMOTBL_H__

#include "heap.h"
#include "closure.h"
#include "../adt/freeset.h"

#define HASHTBL(suffix) memotbl##suffix
#define HASHTBL_HASH_FUN(node) actk__closure_hashval((actk_closure_t*)node)
#define HASHTBL_MALLOC_ARRAY(sz) actk_libc_malloc(sz)
#define HASHTBL_FREE_ARRAY(sz, ptr) actk_libc_free(ptr)

#include "../adt/hashtbl.h"

#undef HASHTBL
#undef HASHTBL_HASH_FUN
#undef HASHTBL_MALLOC_ARRAY
#undef HASHTBL_FREE_ARRAY

/**
 * \defgroup actk_private_memotbl Memotbl
 * \ingroup actk_private
 * @{
 */

actk_closure_t*
actk_memo_match(actk_state_t* st, memotbl_t* memotbl, actk_closure_t* closure);

/* @} */

#endif
