#ifndef __MODREF_H__
#define __MODREF_H__

#include "actk_types.h"
#include "readlist.h"

/**
 * \defgroup actk_private_modref Modref
 * \ingroup actk_private
 * @{
 */

actk_modref_t*    actk_modref_init(actk_state_t* st, actk_modref_t* m);
actk_modref_t*    actk_modref_new(actk_state_t* st, int keyc, void** keyv);
actk_val_t        actk_deref(actk_state_t* st, actk_modref_t* m);
void              actxk_write(actk_state_t* st, actk_modref_t* m, actk_val_t v);
readlist_handle_t actk_modref_read(actk_state_t* st, actk_modref_t* m, actk_closure_t* closure);

/* Shadow modrefs: */
void actk_modref_shadow_w_target(actk_state_t* st, actk_modref_t* m, actk_modref_t* m_target);
void actk_modref_shadow_w_val(actk_state_t* st, actk_modref_t* m, actk_val_t v);
void actk_modref_shadow_replace(actk_state_t* st, actk_modref_t* m_old, actk_modref_t* m_new);

/* @} */

#endif
