#ifndef __MODREF_IMPL__
#define __MODREF_IMPL__

#include "modref.h"
#include "actk_types.h"
#include "readlist.h"

/**
 * \addtogroup actk_private_modref
 * @{
 */

typedef enum {
  MODREF_BEHAV_NORMAL = 0,
  MODREF_BEHAV_SHADOW = 1
} actk_modref_behav_t;

typedef enum {
  MODREF_STATE_EMPTY = 0,
  MODREF_STATE_WRITTEN = 1,
} actk_modref_state_t;

struct actk_modref_s {
  /* TODO: These should be packed into spare flags of first word
     (either readlist or target) to conserve space. */
  short /*actk_modref_behav_t*/ _behav;
  short /*actk_modref_state_t*/ _state;
  
  union {
    /* case: Normal behavior */
    struct {
      readlist_t readlist;
      actk_val_t val;
    } normal;

    /* case: Shadow behavior */
    struct {
      actk_modref_t* target;
      actk_val_t val;
    } shadow;    
  } u;
};

/* TODO: these should mask and unmask packed flags: */
#define ACTK_MODREF_BEHAV(m) ((m)->_behav)
#define ACTK_MODREF_STATE(m) ((m)->_state)

/* @} */

#endif
