#ifndef __TIMESTAMP_H__
#define __TIMESTAMP_H__

#include "heap.h"
#include "../adt/pointer.h"
#include "../adt/freeset.h"

#define TOTALORDER_MALLOC(sz) actk_freeset_malloc(sz)
#define TOTALORDER_FREE(sz,ptr) actk_freeset_free(sz, ptr)
#include "../adt/totalorder.h"
#undef TOTALORDER_MALLOC 
#undef TOTALORDER_FREE

/**
 * \defgroup actk_private_timestamp Timestamp
 * \ingroup actk_private
 * @{
 */

/* A timestamp is just a node in the total-order */
typedef to_node_t actk_timestamp_t;

typedef enum {
  ACTK_TIMESTAMP_CLOSURE_START,
  ACTK_TIMESTAMP_RECCTX_END,
  ACTK_TIMESTAMP_OTHER,
} actk_timestamp_type_t;

extern to_data_t actk_timestamp_nulldata;

/* An interval is a pair of timestamps -- an interval is "valid" if
   both timestamps are live, in the same ordering, and the first
   timestamp is <= the second */
struct actk_interval_s {
  actk_timestamp_t* start;
  actk_timestamp_t* end;
};

/* @} */

#endif
