/* Matthew Hammer  */
/* <hammer@tti-c.org> */

#ifndef __ACTK_H__
#define __ACTK_H__

#include <string.h>
#include <stdarg.h>

/** \defgroup actk_public ACTK Public API
    \paragraph asdkfasdfklasd asdf
*/

/** \defgroup actk_stdlib ACTK Standard-Lib, Apps & Examples
 */

/** \defgroup actk_private ACTK Implementation
 */

#include "../core/actk_types.h"


/** \defgroup actk_public_meta Meta-Level
 *  \ingroup actk_public
 */
/* @{ */
void actk_init(actk_state_t* st, int argc, char** argv);
void actk_propagate(actk_state_t* st);
void actk_freeall(actk_state_t* st);
void actk_clear(actk_state_t* st);
void actk_cleanup(actk_state_t* st);
/* @} */

/** \defgroup actk_public_mm Memory management
 *  \ingroup actk_public
 */
/* @{ */
void*             actk_alloc  (actk_state_t* st, int size, ...);
void              actk_garbage(actk_state_t* st, void* p);
actk_modref_t*    actk_modref (actk_state_t* st, ...);
actk_val_t        actk_deref  (actk_state_t* st, actk_modref_t* m);
/* @} */

/** \defgroup actk_public_closures Closure-construction
 *  \ingroup actk_public
 */
/* @{ */
actk_closure_t* actk_closure(actk_state_t* st, actk_fun_t* fun, ...);
actk_val_t      actk_rkey(actk_val_t v);     /* Recursive key */
actk_val_t      actk_read(actk_modref_t* m); /* Dereference Modref */
actk_val_t      actk_pass(actk_val_t v);     /* Pass value through */
/* @} */

/** \defgroup actk_public_prim Primitives
    \ingroup actk_public
    @{ */
void actk_run   (actk_state_t* st, actk_closure_t* closure);
void actk_call  (actk_state_t* st, actk_fun_t* fun, ...);
void actk_write (actk_state_t* st, actk_modref_t* m, actk_val_t v);
/* @} */

#include "../core/actk_macros.h"
#include "../core/actk_debug.h"
#include "../core/logging.h"

/* TODO: remove need for state and closure implementation headers: */
#include "../core/state_impl.h"
#include "../core/closure_impl.h"

#include "../core/stats.h"
#include "../core/modref.h"
#include "../core/heap.h"


#endif
