/* Matthew Hammer  */
/* <hammer@tti-c.org> */

#ifndef __DIAMETER_H__
#define __DIAMETER_H__

#include "modlist.h"

/**
 * \addtogroup actk_stdlib_geom2d
 * @{
 */

ACTK_FUN_SIG(diameter, "diameter",
             "The distance between the furthest two points in list l "
             "[i.e., distance d = argmax (over points p1, p2 in l) dist(p1, p2)]",
             ACTK_FUN_ARG("l",    modlist_t*,      CONST_VAL),
             ACTK_FUN_ARG("d",    actk_modref_t*,  CONST_DST),
             );

ACTK_FUN_SIG(distance, "distance",
             "The distance between the closest pair of points from two lists"
             "(we assume that these two point-clouds are disjoint)",
             ACTK_FUN_ARG("l1",   modlist_t*,      CONST_VAL),
             ACTK_FUN_ARG("l2",   modlist_t*,      CONST_VAL),
             ACTK_FUN_ARG("d",    actk_modref_t*,  CONST_DST),
             );

/* @} */

#endif
