#include "quicksort.h"
#include "modutil.h"

ACTK_FUN(quicksort_via_split,
         quicksort_via_split_,
         ACTK_USEMEMOTABLE | ACTK_USEALLOCTABLE );

void quicksort_via_split_(actk_state_t* st) {
  actk_fun_begin(st);
  modlist_cell_t* pivot_cell = actk_fun_arg(st);
  modlist_cell_t*          z = actk_fun_arg(st);
  actk_modref_t*        dest = actk_fun_arg(st);
  modlist_cell_pred_t*  comp = actk_fun_arg(st);
  
  if(!pivot_cell) {
    actk_write(st, dest, z);
  }
  else {
    actk_val_t         pivot = pivot_cell->head;
    actk_modref_t*  split_le = actk_modref(st, pivot);
    actk_modref_t*  split_gt = actk_modref(st, pivot);
    modlist_cell_t*  z2_cell = modlist_cell_keyed(st, pivot);
    
    actk_call(st, modlist_split,
              actk_rkey(pivot),
              actk_read(pivot_cell->tail),
              actk_pass(split_le),
              actk_pass(split_gt),
              actk_pass(comp),
              actk_pass(pivot)
              );
    
    actk_call(st, quicksort_via_split,
              actk_read(split_le),
              actk_pass(z2_cell),
              actk_pass(dest)
              );
    
    actk_call(st, quicksort_via_split,
              actk_read(split_gt),
              actk_pass(z),
              actk_pass(z2_cell->tail)
              );

  }
  actk_fun_end(st);
}
