#include "test_apps.h"
#include "test_modlist.h"
#include "test_exprtree.h"
#include "test_bst.h"

test_app_t* test_app_from_name(const char* name) {
  test_app_t* test_app = malloc(sizeof(test_app_t));
  test_app->name = name;

  if( !strcmp(name, "quicksort") ||
      !strcmp(name, "mergesort") ||
      !strcmp(name, "filter") ||
      !strcmp(name, "sum") ||
      !strcmp(name, "map") ||
      !strcmp(name, "minimum") ||
      !strcmp(name, "reverse") ||
      !strcmp(name, "split") ||
      !strcmp(name, "merge") ||
      !strcmp(name, "traverse") ||
      !strcmp(name, "cross") ||
      !strcmp(name, "quickhull") ||
      !strcmp(name, "diameter") ||
      !strcmp(name, "distance")
      )
  {
    test_app->hooks = &test_hooks_modlist;    
    return test_app;
  }
  else if( !strcmp(name, "exprtree") )
  {
    test_app->hooks = &test_hooks_exprtree;
    return test_app;
  }
  else if( !strcmp(name, "bst") )
  {
    test_app->hooks = &test_hooks_bst;
    return test_app;
  }  
  else
  {
    return NULL;
  }  
}
