#ifndef __TEST_HOOKS__
#define __TEST_HOOKS__

#include "actk.h"
#include "test_types.h"

typedef void (*test_do_funptr_t) (actk_state_t* st,
                                  test_params_t* test_params,
                                  test_state_t* test_st);

typedef void (*test_print_funptr_t) (actk_state_t* st,
                                     test_params_t* test_params,
                                     test_state_t* test_st, FILE* file);

struct test_hooks_s {
  test_do_funptr_t    do_gen_input;
  test_do_funptr_t    do_initial_run;
  test_do_funptr_t    do_prechange;
  test_do_funptr_t    do_replace;
  test_do_funptr_t    do_insert;
  test_do_funptr_t    do_remove;  
  test_print_funptr_t print_input;
  test_print_funptr_t print_output;
};

#endif
