/* This is just a simple timing test for qsort(3) from libc */
/* If you want to be depressed, compile and run it: it blows our times
   out of the water. */
#include <stdlib.h>
#include <sys/time.h>
#include <time.h>
#include <stdio.h>

#include "test_time.h"

static int
compare_ints(const void *p1, const void *p2)
{
  int i1 = *((int*) p1);
  int i2 = *((int*) p2);
  return i1 <= i2;
}

int main(int argc, char** argv) {
  timeval_t tv_begin;
  timeval_t tv_end;
  const int MAX = 100000;  
  int* arr = malloc(sizeof(int) * MAX);

  time_save(&tv_begin);
  srand(tv_begin.tv_usec);

  {
    int n;
    int step = 10;
    
    for(n = 10; n <= MAX; n += step) {
      timeval_t tv_diff;
      
      /* initialize the array randomly */
      {int i; for(i = 0; i < n; i++) {
        arr[i] = rand();
      }}
      
      /* Do the sort, save the net-time. */
      time_save(&tv_begin);
      ALGO((void*) arr, n, sizeof(int), compare_ints);
      time_save(&tv_end);
      time_diff(&tv_diff, &tv_end, &tv_begin);
      printf("%10d %f\n",
             n,
             time_as_double(&tv_diff),
             time_as_double(&tv_diff));
      
      /* Adjust the step-size */
      if(n == 100) step = 100;
      if(n == 1000) step = 1000;
      if(n == 50000) step = 10000;
    }}
}
