#ifndef __TEST_PARAMS_H__
#define __TEST_PARAMS_H__

#include <stdio.h>
#include "test_types.h"

typedef enum {
  TEST_FLAGVAL__FIRST,
  TEST_FLAGVAL_OFF,
  TEST_FLAGVAL_ON,
  TEST_FLAGVAL_FORCE_OFF,
  TEST_FLAGVAL_FORCE_ON,
  TEST_FLAGVAL__LAST,
} test_flagval_t;

typedef enum {
  TEST_CHANGE__FIRST,
  TEST_CHANGE_REPLACE,
  TEST_CHANGE_INSERT,
  TEST_CHANGE_REMOVE,
  TEST_CHANGE__LAST
} test_change_t;

struct test_params_s {
  test_app_t *app;
  int rand_seed;
  int input_size;
  int full_loops;
  int change_loops;
  int change_skip;
  int change_limit;
  test_flagval_t change_do_replace;
  test_flagval_t change_do_ins_rem;
  test_flagval_t print_inout;
  test_flagval_t write_stats;
  test_flagval_t write_timestamps;
  test_hooks_t*  hooks;
};

void        test_params_print(test_params_t* test_params, FILE* f);
void        test_params_default(test_params_t* test_params);
int         test_params_from_argv(test_params_t* test_params, int argc, char** argv);

const char* test_flagval_name(test_flagval_t flagval);
int         test_flagval(test_flagval_t flagval);
const char* test_change_name(test_change_t change);

#endif
