#include "test_params.h"

#include <unistd.h>
#include <signal.h>
#include <stdlib.h>
#include <stdio.h>
#include <errno.h>

/*
#include <bits/siginfo.h>
#include <bits/sigaction.h>
#include <bits/sigset.h>
*/

static test_params_t* signalhandler_test_params = NULL;

static void test_signalhandler(int sig) {
  const char* msg = __FUNCTION__;
  fprintf(stderr, "%s: Got signal %d\n", msg, sig);
  fprintf(stderr, "%s: printing test parameters:\n", msg);
  test_params_print(signalhandler_test_params, stderr);
  exit(EXIT_FAILURE);
}

void test_install_signalhandler(test_params_t* test_params) {
  signalhandler_test_params = test_params;  
  /*  int signals[] = {SIGSEGV, SIGABRT, SIGILL}; */
  int signals[] = { };
  int signalc   = sizeof(signals) / sizeof(SIGSEGV);
  
  /* Install the handler for each signal */{
    {int i; for(i = 0; i < signalc; i++) {
      if (signal(signals[i], test_signalhandler) == SIG_ERR) {
        perror("sigaction");
        exit(EXIT_FAILURE);
      }
    }}
  }
}
