#include "test_state.h"
#include <strings.h>

/* ------ Test-state ------- */

void test_state_init(actk_state_t* st,
                     test_params_t* test_params,
                     test_state_t* test_st)
{
  bzero(test_st, sizeof(test_state_t));
  
  {int i; for(i = 0; i < MAX_INOUT_ARITY; i++) {
    test_st->input[i] = NULL;
    test_st->output[i] = actk_modref(st);
  }}
  
  test_st->file_stats     = fopen("test-stats.out", "w+");
  test_st->file_stats_cum = fopen("test-stats-cum.out", "w+");
  test_st->change_count   = 0;
  test_st->change_phase   = 0;
}

void test_state_cleanup(actk_state_t* st,
                        test_params_t* test_params,
                        test_state_t* test_st) {  
  fclose(test_st->file_stats);
  fclose(test_st->file_stats_cum);
}

void stats_file_preamble(actk_stats_t* stats, FILE* file) {
  actk__stats_print_column_key(stats, 4, file);
  fprintf(file, "#\n");
  fprintf(file, "#%9d %10d %10d ", 1, 2, 3);
  actk__stats_print_header(stats, 4, file);
  fprintf(file, "\n#\n");
}

void test_stat_file_entry(actk_stats_t* stats, int i,
                          const char* comment, FILE* file)
{
  static int count = 0;
  
  fprintf(file, "%10d %10d %10s ", count++, i, comment);
  actk__stats_print_line(stats, file);
  fprintf(file, "\n");
}
