#ifndef __TEST_STATE__
#define __TEST_STATE__

#include "actk.h"
#include "test_types.h"
#include "test_time.h"

#include <stdio.h>

#define MAX_INOUT_ARITY 2

/* ------- Test-State ------- */
/* -- used to create a common state for writing the "testing functor" */
struct test_state_s {
  actk_modref_t* input  [MAX_INOUT_ARITY];
  actk_modref_t* output [MAX_INOUT_ARITY];

  FILE*          file_stats;
  FILE*          file_stats_cum;

  actk_stats_t   stats_begin_initial;
  actk_stats_t   stats_delta_initial;
  timeval_t      time_begin_initial;
  timeval_t      time_delta_initial;
  timeval_t      time_end_initial;
  
  actk_modref_t* change_modref;  
  int            change_index;
  int            change_index_delta;
  int            change_count;
  int            change_phase;
  
  actk_stats_t   stats_begin_changes;
  actk_stats_t   stats_delta_changes;
  timeval_t      time_begin_changes;
  timeval_t      time_delta_changes;
  timeval_t      time_end_changes;  
};

void test_state_init(actk_state_t* st,
                     test_params_t* test_params,
                     test_state_t* test_st);

void test_state_cleanup(actk_state_t* st,
                        test_params_t* test_params,
                        test_state_t* test_st);

void stats_file_preamble(actk_stats_t* stats, FILE* file);
  
void test_stat_file_entry(actk_stats_t* stats, int i,
                          const char* comment, FILE* file);

#endif
