#include <stdio.h>
#include <stdlib.h>
#include <time.h>

typedef struct chunk_s {
  struct chunk_s* next;
  unsigned char padding[60];
} chunk_t;

unsigned long long nlivebytes = 0;

void print_status() {
  fprintf(stderr, "status: allocated %llu bytes (%llu MB, %llu MB)\n",
          nlivebytes,
          nlivebytes / (1 << 20),
          nlivebytes / 1000000);
}



int main(int argc, char** argv) {
  chunk_t* first_chunk = NULL;
  chunk_t* last_chunk = NULL;
  time_t last_time = time(NULL);

  fprintf(stderr, "chunk-size is %d bytes\n", sizeof(chunk_t));
  
  while(1) {
    chunk_t* chunk = malloc(sizeof(chunk_t));
    
    if(chunk) {
      nlivebytes += sizeof(chunk_t);
      if(last_chunk) {
        last_chunk->next = chunk;
        last_chunk = chunk;
      }
      else {
        first_chunk = last_chunk = chunk;
      }
    }
    else {
      print_status();
      perror("malloc");
      exit(EXIT_FAILURE);
    }
  
    {
      time_t now = time(NULL);
      if(now > last_time + 1) {
        last_time = now;
        print_status();
      }
    }
  }
}
