#!/usr/bin/env perl
use strict;

my $z1M = [100, 500, 1000, 5000, 10000, 50000, 100000,
           200000, 300000, 400000, 500000,
           600000, 700000, 800000, 900000,
           1000000];

my $z2M = [@$z1M, 1250000, 1500000, 1750000, 2000000];

my $z100k = [100, 500, 1000, 2500, 5000, 7500, 10000, 
             20000, 30000, 40000, 50000,
             60000, 70000, 80000, 90000,
             100000];

my $z300k = [@$z100k, 135000, 150000, 202500, 273375, 300000];

my $apps = [
#            ["filter", $z1M],
            ["map", $z2M],
#            ["minimum",$z1M],
            ["sum",$z2M],
#            ["quicksort",$z100k],
            ["mergesort",$z100k],
            ["quickhull",$z300k],
#            ["diameter",$z100k],
#            ["distance",$z100k],
#            ["exprtree",$z1M],
#            ["bst",$z1M]
            ];

# USE_FREESET = 1
my $bin = "../../bin/actk.perf";

for my $app_sizes (@$apps) {
    my ($app, $sizes) = @$app_sizes;

    for my $size (@$sizes) {
        my $cmdstr = ($bin . " -input-size $size -app $app +actk-bookkeeping 2> /dev/null");
        my $out = `$cmdstr`;
        my $time = -1;
        
        if($out =~ /initial-time = (.*)/) { $time = $1; }
        else { die "\"$cmdstr\""; }
        
        printf("%16s %16s %s\n", $app, $size, $time);
    }
}
